#!/bin/bash
ERRORS=0
if [ "$1" = "" ]
then
  pushd . >/dev/null
else
  echo Checking $1 ...
  pushd $1 >/dev/null
fi
if [ ! -f series ]
then
  echo no series file found
  popd >/dev/null
  exit 1
fi
for i in *
do
  if [ "$i" != "series" -a "$i" != "status" ]
  then
    j=`echo $i | sed -e 's@[A-Za-z0-9_.-]@@g'`
    if [ "$j" != "" ]
    then
      echo illiegal character\(s\) \'$j\' in filename \'$i\'
      ERRORS=`expr $ERRORS + 1`
    fi
    j=`echo $i | sed -e 's@\.@\\\.@g'`
    COUNT=`grep ^$j$ series | wc | sed -e 's@^\s*@@g' -e 's@ .*$@@g'`
    if [ "$COUNT" != "1" ]
    then
      ERRORS=`expr $ERRORS + 1`
      echo $i appears $COUNT times in series
    fi
  fi
done
for i in `cat series`
do
  if [ ! -f $i ]
  then
    echo File $i in series does not exist.
    ERRORS=`expr $ERRORS + 1`
    echo $i
  fi
done
popd >/dev/null
if [ "$ERRORS" = "0" ]
then
  echo no errors detected
  exit 0
else
  if [ "$ERRORS" = "1" ]
  then
    echo 1 error detected
  else
    echo $ERRORS errors detected
  fi
fi
exit 1
